# -*- coding: utf-8 -*-
import pygame as pg
from pygame.locals import *
import sys
import time
import serial   #モジュール名はpyserialだが, importする際はserialである

#シリアル通信で文字をArduino側に送信

#UID CODE テキスト　エディタ　などで　予め調べておく
cards=["******","******","******","******","******",
        "******","******","******","******","*****","config"]
#カードの名前例：　動物名
names=["コアラ","イヌ","ネコ","ペンギン","ライオン",
        "トラ","ゾウ","ウサギ","リス","パンダ"]
#-----------Main Routine----------------------------------------------------
(w,h) = (1350,700)

pg.init()
pg.display.set_mode((w, h))
#システムフォントの指定
font = [
    pg.font.SysFont("ipaゴシック", 20),
    pg.font.SysFont("ipaゴシック", 40),
    pg.font.SysFont("ipaゴシック", 60)
]
#アイコン画像：自分で用意する必要があります　サイズ160x160程度
icons=[pg.image.load("./animals/0_koala.png").convert_alpha(),
    pg.image.load("./animals/1_dog.png").convert_alpha(),
    pg.image.load("./animals/2_cat.png").convert_alpha(),
    pg.image.load("./animals/3_penguin.png").convert_alpha(),
    pg.image.load("./animals/4_lion.png").convert_alpha(),
    pg.image.load("./animals/5_tiger.png").convert_alpha(),
    pg.image.load("./animals/6_elephant.png").convert_alpha(),
    pg.image.load("./animals/7_rabbit.png").convert_alpha(),
    pg.image.load("./animals/8_squirrel.png").convert_alpha(),
    pg.image.load("./animals/9_panda.png").convert_alpha()]
#----------------------------------------------------------------  
# 設定
# pygameの初期化
pg.init()
screen = pg.display.get_surface()

def main():
    inputs=''
    msg=''
    na=''
    prein=''
    ban=''
    num=-1
    with serial.Serial('COM**',9600,timeout=1) as ser: #com** Arduino port
        while True:
            pg.time.wait(50)
            screen.fill((173,200,144))

            pg.draw.rect(screen,(255,255,255),(150,150,700,420),0)
            pg.draw.rect(screen,(0,0,255),(180,180,640,360),4)
            pg.draw.line(screen,(0,0,255),(180,300),(820,300),4)
            pg.draw.line(screen,(0,0,255),(180,420),(820,420),4)
            pg.draw.line(screen,(0,0,255),(450,180),(450,540),4)
            
            label0=font[2].render('カードをスキャンして下さい', True,(255,0,0))
            label1a=font[1].render("UID", True,(0,0,0))
            label2a=font[1].render("カード番号", True,(0,0,0))
            label3a=font[1].render("名前", True,(0,0,0))
            label1b=font[1].render(prein, True,(0,0,0))
            label2b=font[1].render(ban, True,(0,0,0))
            label3b=font[1].render(na, True,(0,0,0))
            
            screen.blit(label0,(100,50))
            screen.blit(label1a,(220,220))
            screen.blit(label2a,(220,340))
            screen.blit(label3a,(220,460))
            if num != -1: screen.blit(icons[num],(1000,250))
            screen.blit(label1b,(550,220))
            screen.blit(label2b,(550,340))
            screen.blit(label3b,(550,460))
            
            pg.display.update()
            
            for e in pg.event.get():
                # 終了ボタン
                if e.type == QUIT:
                    ser.close()
                    pg.quit()
                    sys.exit()
                if e.type == pg.KEYDOWN:
                    if e.key == pg.K_RETURN:
                        num=-1;
                        msg=''
                        na=''
                        ban=''
                        for i in range(11):
                            if i==10 and inputs[0:6]==cards[10]:
                                num=0
                            elif i<10 and inputs==cards[i]:
                                num=i
                        if num>=0:
                            ban=str(num+1)
                            na=names[num]
                            msg=str(num)
                            flag=bytes(msg,'utf-8')
                            ser.write(flag)
                        prein=inputs
                        inputs=''
                    else :
                        inputs += e.unicode
                   

if __name__ == "__main__":
    main()